///
/// Copyright (c) 2018, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

library haystack.list_test;

import 'package:haystack/haystack.dart';
import 'package:test/test.dart';

import 'utils.dart';

void main() {
  group("HListTest", ()
  {
    test("Empty", () {
      expect(HList.EMPTY, HList([]));
      expect(HList.EMPTY, HList(List<HVal?>.empty()));
      expect(HList.EMPTY.size, 0);
      expect(HList.EMPTY.isEmpty, true);
      expect(() => HList.EMPTY.get(0), throwsA(anything));
    });

    test("Basics", () {
      HRef ref = HRef("a");
      HStr str = HStr("string");
      List<HVal> items = [];
      items.add(ref);
      items.add(str);

      HList list = HList(items);
      expect(list.length, 2);
      expect(list.get(0), ref);
      expect(list.get(1), str);

      expect(list[0], ref);
      expect(list[1], str);
    });

    test("Zinc", () {
      verifyZinc(HList.EMPTY, "[]");
      // TODO: more tests
    });
  });
}
